=== debian/changelog ===
libcgns (3.3.0-7~deb10u1) buster; urgency=medium

  * Rebuild for buster.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 14 Jan 2020 01:10:12 +0100

libcgns (3.3.0-7) unstable; urgency=medium

  * Backport fix from experimental
  * New patch gcc-pr92361.patch to fix FTBFS on ppcel64 (closes: #944127)

 -- Gilles Filippini <pini@debian.org>  Sat, 16 Nov 2019 10:19:19 +0100

libcgns (3.3.0-6) unstable; urgency=medium

  [ Aurelien Jarno ]
  * New patch no-matherr.patch to fix FTBFS against glibc 2.27
    (closes: #890271)

 -- Gilles Filippini <pini@debian.org>  Tue, 06 Mar 2018 21:22:21 +0100

libcgns (3.3.0-5) unstable; urgency=medium

  * Team upload.
  * Moved packaging from SVN to Git
  * cme fix dpkg-control
  * debhelper 11
  * Standards-Version: 4.1.3

 -- Andreas Tille <tille@debian.org>  Fri, 26 Jan 2018 13:48:45 +0100

libcgns (3.3.0-4) unstable; urgency=medium

  * New patch no-rpath.patch to prevent setting rpath on generated
    binaries
  * Drop useless cgnames.1 manpage
  * debian/control:
    - Fix VCS fields
    - Bump Standards-Version to 3.9.8 (no changes)

 -- Gilles Filippini <pini@debian.org>  Tue, 10 Jan 2017 18:40:22 +0100

libcgns (3.3.0-3) unstable; urgency=medium

  * Rename /usr/bin/unitconv to /usr/bin/cgns_unitconv because unitconv
    is already used by unrelated package xcrysden (closes: #848344)

 -- Gilles Filippini <pini@debian.org>  Mon, 26 Dec 2016 10:37:18 +0100

libcgns (3.3.0-2) unstable; urgency=medium

  * New patch fix-p3dfout.patch to fix FTBFS on hurd and kfreebsd

 -- Gilles Filippini <pini@debian.org>  Thu, 15 Dec 2016 19:50:49 +0100

libcgns (3.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Gilles Filippini <pini@debian.org>  Sun, 11 Dec 2016 15:01:12 +0100

libcgns (3.1.4.2-3) unstable; urgency=medium

  * Set compatibility level to 10 (closes: #830460)
  * debian/control: Uploaders: Replace Sylvestre with myself

 -- Gilles Filippini <pini@debian.org>  Tue, 19 Jul 2016 12:12:32 +0200

libcgns (3.1.4.2-2) unstable; urgency=low

  * Team upload.
  * Support hdf5 1.8.13 new packaging layout (closes: #756673).

 -- Gilles Filippini <pini@debian.org>  Fri, 25 Jul 2014 10:45:50 +0200
